`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    10:47:18 01/27/06
// Design Name:    
// Module Name:    DDC_DATA_CAP
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module DDC_DATA_CAP(	FPGA_CLK,
							FPGA_RESET,
							DCLK_EN,
							DOUT_IN,
							CAP_DATA_OUT,
							BITS_TO_READ,
							FORMAT,
							DATA_READY,
							ACK,
							READ_ONE_DATA_SET_FROM_DDC,
							DONE_READING_DATA_SET_FROM_DDC,
							DCLK_OUT,
							DCLK_SEL,
							DIVXCLK_LOW_REG,
							DIVXCLK_HIGH_REG,
							DCLK_WAIT_COUNT,
							FIRST_READINGS,
							RESET_AVGRAM_ADDR,
							STOP_ADDR,
							AB_AVG_SEL,
							TRIGGER_READ_RAM,
							AVG_DATA_OUTPUT,
							AVG_DATA_AVAILABLE_FOR_WRITE,
							AVG_DATA_LOADED,
							USB_WRITE_DATA_REQUESTED,
							USB_WRITE_DATA_PROCESSED,
							CONV_A0_B1,
							PAUSE_FOR_CONV
							
							);							

input FPGA_CLK;
input FPGA_RESET;
output DCLK_EN;
reg DCLK_EN;
input DOUT_IN;
output [19:0] CAP_DATA_OUT;
wire [19:0] CAP_DATA_OUT;
input [14:0] BITS_TO_READ;
input FORMAT;
output DATA_READY;
reg DATA_READY;
input ACK;
input READ_ONE_DATA_SET_FROM_DDC;		  //////this is where I left of working 2/3/06  I need to trigger a bit_to_read parallel load then decr.
output DONE_READING_DATA_SET_FROM_DDC;
reg DONE_READING_DATA_SET_FROM_DDC;

output DCLK_OUT;
reg DCLK_OUT;
input [2:0] DCLK_SEL;
input [3:0] DIVXCLK_LOW_REG;
input [3:0] DIVXCLK_HIGH_REG;
input [15:0] DCLK_WAIT_COUNT;
input [1:0] FIRST_READINGS;
input RESET_AVGRAM_ADDR;
input [9:0] STOP_ADDR;
input AB_AVG_SEL;
input TRIGGER_READ_RAM;

output [15:0] AVG_DATA_OUTPUT;
reg [15:0] AVG_DATA_OUTPUT;

output AVG_DATA_AVAILABLE_FOR_WRITE;
reg AVG_DATA_AVAILABLE_FOR_WRITE;

output AVG_DATA_LOADED;
reg AVG_DATA_LOADED;

input USB_WRITE_DATA_REQUESTED;
input USB_WRITE_DATA_PROCESSED;

input CONV_A0_B1;
input PAUSE_FOR_CONV;

//input USER_DCLK_N, TRIGGER_SREG_WRITE_W, CLK_TM_264, USER_DCLKN_O, DCLK_SELECT, DCLOCK_MANUAL, DDC_ACQ_DCLK_W, DDC_IO1_O_1, DDC_IO1_O;
//input [1:0] BOARD_W;


reg load_bigcount_i;
reg decr_bigcount_i;
reg load_count_i;
reg decr_count_i;
reg done_reading_data_set_from_ddc_i;
reg read_bit_i;
reg toggle_cap_sel;
reg [14:0] bigcount;
reg [4:0] count;
reg [3:0] FSMn, FSM;
reg [19:0] cap_data_out_0;
reg [19:0] cap_data_out_1;
reg cap_sel;
reg data_ready_i;
reg dclk_en_i;
reg reset_divxclk_low_count_i;
reg reset_divxclk_high_count_i;
reg decr_divxclk_low_count_i;
reg decr_divxclk_high_count_i;
reg reset_dclk_wait_i;
reg decr_dclk_wait_i;

reg dclk_i, dclk_out_reg;
reg [3:0] divXclk_count_low;
reg [3:0] divXclk_count_high;
reg [15:0] dclk_wait_count_reg;

reg trigger_store_sum_i, trigger_store_sum;


parameter	IDLE = 4'b0000,
				DCLK_WAIT_STATE = 4'b0001,
				DCLK_HIGH_STATE = 4'b0010,
				DCLK_LOW_STATE = 4'b0011,
				WAIT_FOR_ACK_FROM_FIFO = 4'b0100,
				ADD_ONE_DCLK = 4'b0101,
				DONE_STATE = 4'b0110,
				DCLK_HIGH_PAUSE_FOR_CONV = 4'b0111,
				DCLK_LOW_PAUSE_FOR_CONV = 4'b1000,
				DCLK_WAIT_PAUSE_FOR_CONV = 4'b1001;
				
parameter	oIDLE=4'h0,
				oDATA_AVAILABLE_NOW_WAIT=4'h1,
				oDATA_LOADED_FOR_USB=4'h2,
				oEVALUATE_NEXT_REGISTER=4'h3,
				oDONE=4'hF;


assign CAP_DATA_OUT[19:0]= (cap_sel==1'b0)?cap_data_out_1[19:0]:cap_data_out_0[19:0];

always @(posedge FPGA_CLK or negedge FPGA_RESET)
	begin
		if(FPGA_RESET==1'b0)
			begin
				FSM=IDLE;
				bigcount[14:0]=15'b000_0000__0000_0000;
				count[4:0]=5'b00000;

				divXclk_count_low[3:0] = 4'h2;
				divXclk_count_high[3:0] = 4'h2;						  
				dclk_wait_count_reg[15:0]=16'h0010;
				
				DATA_READY=1'b0;
				DONE_READING_DATA_SET_FROM_DDC=1'b0;
				DCLK_EN=1'b0;
				DCLK_OUT = 1'b0;

				cap_sel=1'b0;
				cap_data_out_0[19:0]=20'h00000;
				cap_data_out_1[19:0]=20'h00000;
				
				trigger_store_sum = 1'b0;
				
			end
		else
			begin
				FSM=FSMn;
				if(load_bigcount_i==1'b1)              bigcount[14:0] = BITS_TO_READ[14:0];
				if(decr_bigcount_i==1'b1)              bigcount[14:0] = bigcount[14:0] -15'h0001;
				if(load_count_i==1'b1 && FORMAT==1'b1)     count[4:0] = 5'b10100;
				if(load_count_i==1'b1 && FORMAT==1'b0)     count[4:0] = 5'b10000;
				if(decr_count_i==1'b1)                     count[4:0] = count[4:0] -5'h01;

				if(reset_divxclk_low_count_i==1'b1)     divXclk_count_low[3:0] = DIVXCLK_LOW_REG[3:0];
				if(reset_divxclk_high_count_i==1'b1)   divXclk_count_high[3:0] = DIVXCLK_HIGH_REG[3:0];
				if(reset_dclk_wait_i==1'b1)          dclk_wait_count_reg[15:0] = DCLK_WAIT_COUNT[15:0];

				if(decr_divxclk_low_count_i==1'b1)    divXclk_count_low[3:0] = divXclk_count_low[3:0]-4'h1;
				if(decr_divxclk_high_count_i==1'b1)  divXclk_count_high[3:0] = divXclk_count_high[3:0]-4'h1;
				if(decr_dclk_wait_i==1'b1)         dclk_wait_count_reg[15:0] = dclk_wait_count_reg[15:0]-16'h0001;

				DATA_READY = data_ready_i;
				DONE_READING_DATA_SET_FROM_DDC = done_reading_data_set_from_ddc_i;
				DCLK_EN = dclk_en_i;
				//DCLK_OUT = (BOARD_W[1:0] == 2'b01)?((DCLK_SELECT==1'b1)?DCLOCK_MANUAL:(((DCLK_EN==1'b1)? (DCLK_SEL[2:0]==3'b000) ? 0 : (DCLK_SEL[2:0]==3'b111)? 1 : dclk_i : (USER_DCLK_N==1'b1)?(TRIGGER_SREG_WRITE_W==1'b1)?CLK_TM_264:USER_DCLKN_O:1'b0)||DDC_ACQ_DCLK_W)):((TRIGGER_SREG_WRITE_W == 1'b1)?DDC_IO1_O_1:DDC_IO1_O);
				//DCLK_OUT = (DCLK_EN==1'b1)? (DCLK_SEL[2:0]==3'b000) ? 0 : (DCLK_SEL[2:0]==3'b111)? 1 : dclk_i : (USER_DCLK_N==1'b1)?(TRIGGER_SREG_W==1'b1)?CLK_TM_264:USER_DCLKN_O:1'b0;
				DCLK_OUT = dclk_i;
	  
				if(toggle_cap_sel==1'b1)                           cap_sel = ~cap_sel;
				if(read_bit_i==1'b1 && cap_sel==1'b0)
					begin
						cap_data_out_0[19:0] = {cap_data_out_0[18:0],DOUT_IN};
					end
				if(read_bit_i==1'b1 && cap_sel==1'b1)
					begin
						cap_data_out_1[19:0] = {cap_data_out_1[18:0],DOUT_IN};
					end
					
				trigger_store_sum = trigger_store_sum_i;
				
			end
	end
 
always @(  FSM or
           bigcount or
           count or
			  divXclk_count_low or
			  divXclk_count_high or
			  dclk_wait_count_reg or
           READ_ONE_DATA_SET_FROM_DDC or
           ACK or
			  PAUSE_FOR_CONV 
           )
	begin
		FSMn=FSM;

		load_bigcount_i=1'b0;
		decr_bigcount_i=1'b0;
		load_count_i=1'b0;
		decr_count_i=1'b0;

		read_bit_i=1'b0;

		toggle_cap_sel=1'b0;
		data_ready_i=1'b0;
		done_reading_data_set_from_ddc_i=1'b0;

		reset_divxclk_low_count_i=1'b0;
		reset_divxclk_high_count_i=1'b0;
		reset_dclk_wait_i=1'b0;

		decr_divxclk_low_count_i=1'b0;
		decr_divxclk_high_count_i=1'b0;
		decr_dclk_wait_i=1'b0; 

		dclk_en_i=1'b0;
		dclk_i=1'b0;
		
		trigger_store_sum_i=1'b0;
       
		case(FSM)
			IDLE:
				begin
					if(READ_ONE_DATA_SET_FROM_DDC==1'b1)
						begin
							FSMn=DCLK_WAIT_STATE;
							load_bigcount_i=1'b1;
							load_count_i=1'b1;	
							reset_dclk_wait_i=1'b1;
							dclk_en_i=1'b1;
						end
					else
						begin
							FSMn=IDLE;
						end
				end
        
			DCLK_WAIT_STATE:
				begin
					if(PAUSE_FOR_CONV==1'b1)
						begin
							FSMn=DCLK_WAIT_PAUSE_FOR_CONV;
						end
					else
						begin
							if(|dclk_wait_count_reg[15:0]==1'b0)
								begin
									FSMn=DCLK_HIGH_STATE;
									dclk_en_i=1'b1;
									reset_divxclk_high_count_i=1'b1;
									dclk_i=1'b1;
								end
							else
								begin
									FSMn=DCLK_WAIT_STATE;
									dclk_en_i=1'b1;
									decr_dclk_wait_i=1'b1;
								end
						end
				end
				
			DCLK_WAIT_PAUSE_FOR_CONV:
				begin
					dclk_en_i=1'b1;
					if(PAUSE_FOR_CONV==1'b1)
						begin
							FSMn=DCLK_WAIT_PAUSE_FOR_CONV;
						end
					else
						begin
							FSMn=DCLK_WAIT_STATE;
						end
				end
			
			DCLK_HIGH_STATE:
				begin
					dclk_en_i=1'b1;
					if(PAUSE_FOR_CONV==1'b1)
						begin
							FSMn=DCLK_HIGH_PAUSE_FOR_CONV;
							dclk_i=1'b1;
						end
					else
						begin
							if(|divXclk_count_high[3:0]==1'b0)
								begin
									FSMn=DCLK_LOW_STATE;
									read_bit_i=1'b1;
									decr_count_i=1'b1;
									decr_bigcount_i=1'b1;
									reset_divxclk_low_count_i=1'b1;
								end
							else
								begin
									FSMn=DCLK_HIGH_STATE;
									dclk_i=1'b1;
									decr_divxclk_high_count_i=1'b1;
								end
						end
				end
				
			DCLK_HIGH_PAUSE_FOR_CONV:
				begin
					dclk_en_i=1'b1;
					dclk_i=1'b1;
					if(PAUSE_FOR_CONV==1'b1)
						begin
							FSMn=DCLK_HIGH_PAUSE_FOR_CONV;
						end
					else
						begin
							FSMn=DCLK_HIGH_STATE;
						end
				end
			
			DCLK_LOW_STATE:
				begin
					dclk_en_i=1'b1;
					if(PAUSE_FOR_CONV==1'b1)
						begin
							FSMn=DCLK_LOW_PAUSE_FOR_CONV;
						end
					else
						begin
							if(|divXclk_count_low[3:0]==1'b0)
								begin
									if(|count[4:0]==1'b1)
										begin
											FSMn=DCLK_HIGH_STATE;
											dclk_i=1'b1;
											reset_divxclk_high_count_i=1'b1;
										end
									else
										begin
											FSMn=WAIT_FOR_ACK_FROM_FIFO;
											data_ready_i=1'b1;
											toggle_cap_sel=1'b1;
											//this is where the 16 or 20 bit word of channel data is captured from the DDC
											//so this is where we add the data to the current sum total
											//(and the current square sum total if we want)
											//and store it in FPGA RAM.
											trigger_store_sum_i=1'b1;
										end
								end
							else
								begin
									FSMn=DCLK_LOW_STATE;
									decr_divxclk_low_count_i=1'b1;
								end		
						end
				end
				
			DCLK_LOW_PAUSE_FOR_CONV:
				begin
					dclk_en_i=1'b1;
					if(PAUSE_FOR_CONV==1'b1)
						begin
							FSMn=DCLK_LOW_PAUSE_FOR_CONV;
						end
					else
						begin
							FSMn=DCLK_LOW_STATE;
						end
				end
        
			WAIT_FOR_ACK_FROM_FIFO:
				begin
					data_ready_i=1'b1;
					if(ACK==1'b1)
						begin
							if(|bigcount[14:0]==1'b1)  //done with channel, not done with all channels
								begin
									FSMn=DCLK_HIGH_STATE;
									dclk_en_i=1'b1;
									dclk_i=1'b1;
									reset_divxclk_high_count_i=1'b1;
									load_count_i=1'b1;
								end
							else //bigcount=0, all done reading all channels, get outta here.
								begin
									FSMn=DONE_STATE;
								end
						end
				end
     
        
			DONE_STATE:
				begin
					if(READ_ONE_DATA_SET_FROM_DDC==1'b1)
						begin
							FSMn=DONE_STATE;
							done_reading_data_set_from_ddc_i=1'b1;
						end
					else
						begin
							FSMn=IDLE;
						end
				end
           
       endcase        
    end












// FPGA RAM stuff for averaging


wire [31:0] AvgRAM_A_DO;        // 32-bit Data Output *
wire [3:0] AvgRAM_A_DOP;    // 4-bit parity Output *
wire [8:0] AvgRAM_ADDR;
reg [8:0] AvgRAM_ADDR_r;  // 9-bit Address Input *
reg [31:0] AvgRAM_A_DI;      // 32-bit Data Input *
wire [3:0] AvgRAM_A_DIP;    // 4-bit parity Input 
reg AvgRAM_EN;      // RAM Enable Input *
wire AvgRAM_A_SSR;    // Synchronous Set/Reset Input
reg AvgRAM_A_WE;       // Write Enable Input *

wire [31:0] AvgRAM_B_DO;        // 32-bit Data Output *
wire [3:0] AvgRAM_B_DOP;    // 4-bit parity Output *
//reg [8:0] AvgRAM_ADDR;  // 9-bit Address Input *
reg [31:0] AvgRAM_B_DI;      // 32-bit Data Input *
wire [3:0] AvgRAM_B_DIP;    // 4-bit parity Input 
//reg AvgRAM_EN;      // RAM Enable Input *
wire AvgRAM_B_SSR;    // Synchronous Set/Reset Input
reg AvgRAM_B_WE;       // Write Enable Input *


wire [3:0] AvgRAM_A_parityerr;
wire AvgRAM_A_parity_error;
wire [3:0] AvgRAM_B_parityerr;
wire AvgRAM_B_parity_error;


reg AvgRAM_EN_i,
	 AvgRAM_A_WE_i,
	 AvgRAM_B_WE_i;
	 
reg load_new_sum_A_i;
reg load_new_sum_B_i;
reg sum_data_A_i;
reg sum_data_B_i;
reg reset_ram_addr_i;
reg incr_ram_addr_i;


reg [3:0] RAMFSM, RAMFSMn;

reg 	[3:0]	oFSM, oFSMn;
reg 	data_available_for_write_i;
reg	reset_reg_address_i;
reg	data_loaded_for_usb_i;
reg	incr_reg_address_i;
reg	usb_write_data_requested_gated;
reg	usb_write_data_processed_gated;
reg read_out_trigger, done_reading_ram;
          
reg [9:0] read_addr; //use [9:1] for addr[8:0]

parameter RAM_IDLE=4'h0,
			 NEW_SUM=4'h1,
			 EXISTING_SUM=4'h2,
			 RAM_WRITE_A=4'h3,
			 RAM_WRITE_B=4'h4,
			 RAM_WAIT=4'h5,
			 RAM_INCR_ADDR=4'h6,
			 READ_RAM=4'h7,
			 READ_RAM_WAIT=4'h8;

   // RAMB16_S36: Virtex-II/II-Pro, Spartan-3/3E 512 x 32 + 4 Parity bits Single-Port RAM
   // Xilinx HDL Language Template, version 10.1

   RAMB16_S36 #(
      .INIT(36'h000000000),  // Value of output RAM registers at startup
      .SRVAL(36'h000000000), // Output value upon SSR assertion
      .WRITE_MODE("READ_FIRST"), // WRITE_FIRST, READ_FIRST or NO_CHANGE

      // The following INIT_xx declarations specify the initial contents of the RAM
      // Address 0 to 127
      .INIT_00(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_01(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_02(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_03(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_04(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_05(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_06(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_07(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_08(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_09(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_0A(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_0B(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_0C(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_0D(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_0E(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_0F(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      // Address 128 to 255
      .INIT_10(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_11(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_12(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_13(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_14(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_15(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_16(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_17(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_18(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_19(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_1A(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_1B(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_1C(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_1D(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_1E(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_1F(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      // Address 256 to 383
      .INIT_20(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_21(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_22(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_23(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_24(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_25(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_26(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_27(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_28(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_29(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_2A(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_2B(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_2C(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_2D(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_2E(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_2F(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      // Address 384 to 511
      .INIT_30(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_31(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_32(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_33(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_34(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_35(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_36(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_37(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_38(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_39(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_3A(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_3B(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_3C(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_3D(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_3E(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_3F(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),

      // The next set of INITP_xx are for the parity bits
      // Address 0 to 127
      .INITP_00(256'h0000000000000000000000000000000000000000000000000000000000000000),
      .INITP_01(256'h0000000000000000000000000000000000000000000000000000000000000000),
      // Address 128 to 255
      .INITP_02(256'h0000000000000000000000000000000000000000000000000000000000000000),
      .INITP_03(256'h0000000000000000000000000000000000000000000000000000000000000000),
      // Address 256 to 383
      .INITP_04(256'h0000000000000000000000000000000000000000000000000000000000000000),
      .INITP_05(256'h0000000000000000000000000000000000000000000000000000000000000000),
      // Address 384 to 511
      .INITP_06(256'h0000000000000000000000000000000000000000000000000000000000000000),
      .INITP_07(256'h0000000000000000000000000000000000000000000000000000000000000000)
   ) AvgRAM_A (
      .DO(AvgRAM_A_DO),      // 32-bit Data Output
      .DOP(AvgRAM_A_DOP),    // 4-bit parity Output
      .ADDR(AvgRAM_ADDR),  // 9-bit Address Input
      .CLK(FPGA_CLK),    // Clock
      .DI(AvgRAM_A_DI),      // 32-bit Data Input
      .DIP(AvgRAM_A_DIP),    // 4-bit parity Input
      .EN(AvgRAM_EN),      // RAM Enable Input
      .SSR(1'b0),    // Synchronous Set/Reset Input
      .WE(AvgRAM_A_WE)       // Write Enable Input
   );

   // End of RAMB16_S36_inst instantiation


   // RAMB16_S36: Virtex-II/II-Pro, Spartan-3/3E 512 x 32 + 4 Parity bits Single-Port RAM
   // Xilinx HDL Language Template, version 10.1

   RAMB16_S36 #(
      .INIT(36'h000000000),  // Value of output RAM registers at startup
      .SRVAL(36'h000000000), // Output value upon SSR assertion
      .WRITE_MODE("READ_FIRST"), // WRITE_FIRST, READ_FIRST or NO_CHANGE

      // The following INIT_xx declarations specify the initial contents of the RAM
      // Address 0 to 127
      .INIT_00(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_01(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_02(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_03(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_04(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_05(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_06(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_07(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_08(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_09(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_0A(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_0B(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_0C(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_0D(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_0E(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_0F(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      // Address 128 to 255
      .INIT_10(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_11(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_12(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_13(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_14(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_15(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_16(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_17(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_18(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_19(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_1A(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_1B(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_1C(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_1D(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_1E(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_1F(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      // Address 256 to 383
      .INIT_20(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_21(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_22(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_23(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_24(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_25(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_26(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_27(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_28(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_29(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_2A(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_2B(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_2C(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_2D(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_2E(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_2F(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      // Address 384 to 511
      .INIT_30(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_31(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_32(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_33(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_34(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_35(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_36(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_37(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_38(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_39(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_3A(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_3B(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_3C(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_3D(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_3E(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),
      .INIT_3F(256'h00000000_00000000_00000000_00000000_00000000_00000000_00000000_00000000),

      // The next set of INITP_xx are for the parity bits
      // Address 0 to 127
      .INITP_00(256'h0000000000000000000000000000000000000000000000000000000000000000),
      .INITP_01(256'h0000000000000000000000000000000000000000000000000000000000000000),
      // Address 128 to 255
      .INITP_02(256'h0000000000000000000000000000000000000000000000000000000000000000),
      .INITP_03(256'h0000000000000000000000000000000000000000000000000000000000000000),
      // Address 256 to 383
      .INITP_04(256'h0000000000000000000000000000000000000000000000000000000000000000),
      .INITP_05(256'h0000000000000000000000000000000000000000000000000000000000000000),
      // Address 384 to 511
      .INITP_06(256'h0000000000000000000000000000000000000000000000000000000000000000),
      .INITP_07(256'h0000000000000000000000000000000000000000000000000000000000000000)
   ) AvgRAM_B (
      .DO(AvgRAM_B_DO),      // 32-bit Data Output
      .DOP(AvgRAM_B_DOP),    // 4-bit parity Output
      .ADDR(AvgRAM_ADDR),  // 9-bit Address Input
      .CLK(FPGA_CLK),    // Clock
      .DI(AvgRAM_B_DI),      // 32-bit Data Input
      .DIP(AvgRAM_B_DIP),    // 4-bit parity Input
      .EN(AvgRAM_EN),      // RAM Enable Input
      .SSR(1'b0),    // Synchronous Set/Reset Input
      .WE(AvgRAM_B_WE)       // Write Enable Input
   );

   // End of RAMB16_S36_inst instantiation




//I calculate parity bits by xoring 8 bits of the 32 together and seeing if there are an even or odd number of 1's in the byte.
//I check the parity bit with the data that was read back by xoring it all together.
//if there are an even number of 1's in the byte, then the xor result will be 0.
//if there are an odd number of 1's in the byte, then the xor result will be 1.
//so when we xor the byte and the parity bit, if the bits are all okay, we will get 0 as the xor result.
//and that means that if we get a 1 as a result, then an odd number of bits are wrong.
//if an even number of bits are wrong, then the result will be 0 still and we won't notice the error.
//if there is an error in any of the 4 bytes, then AvgRAM_parity_error will be 1.

///////////// A side
//calculate parity bits to store with data
assign AvgRAM_A_DIP[0] = AvgRAM_A_DI[7]  ^ AvgRAM_A_DI[6]  ^ AvgRAM_A_DI[5]  ^ AvgRAM_A_DI[4]  ^ AvgRAM_A_DI[3]  ^ AvgRAM_A_DI[2]  ^ AvgRAM_A_DI[1]  ^ AvgRAM_A_DI[0];
assign AvgRAM_A_DIP[1] = AvgRAM_A_DI[15] ^ AvgRAM_A_DI[14] ^ AvgRAM_A_DI[13] ^ AvgRAM_A_DI[12] ^ AvgRAM_A_DI[11] ^ AvgRAM_A_DI[10] ^ AvgRAM_A_DI[9]  ^ AvgRAM_A_DI[8];
assign AvgRAM_A_DIP[2] = AvgRAM_A_DI[23] ^ AvgRAM_A_DI[22] ^ AvgRAM_A_DI[21] ^ AvgRAM_A_DI[20] ^ AvgRAM_A_DI[19] ^ AvgRAM_A_DI[18] ^ AvgRAM_A_DI[17] ^ AvgRAM_A_DI[16];
assign AvgRAM_A_DIP[3] = AvgRAM_A_DI[31] ^ AvgRAM_A_DI[30] ^ AvgRAM_A_DI[29] ^ AvgRAM_A_DI[28] ^ AvgRAM_A_DI[27] ^ AvgRAM_A_DI[26] ^ AvgRAM_A_DI[25] ^ AvgRAM_A_DI[24];

//calculate error detected by parity bits from read data

assign AvgRAM_A_parityerr[0] = (AvgRAM_A_DOP[0] ^ AvgRAM_A_DO[7]  ^ AvgRAM_A_DO[6]  ^ AvgRAM_A_DO[5]  ^ AvgRAM_A_DO[4]  ^ AvgRAM_A_DO[3]  ^ AvgRAM_A_DO[2]  ^ AvgRAM_A_DO[1]  ^ AvgRAM_A_DO[0] == 0)  ? 0 : 1;
assign AvgRAM_A_parityerr[1] = (AvgRAM_A_DOP[1] ^ AvgRAM_A_DO[15] ^ AvgRAM_A_DO[14] ^ AvgRAM_A_DO[13] ^ AvgRAM_A_DO[12] ^ AvgRAM_A_DO[11] ^ AvgRAM_A_DO[10] ^ AvgRAM_A_DO[9]  ^ AvgRAM_A_DO[8] == 0)  ? 0 : 1;
assign AvgRAM_A_parityerr[2] = (AvgRAM_A_DOP[2] ^ AvgRAM_A_DO[23] ^ AvgRAM_A_DO[22] ^ AvgRAM_A_DO[21] ^ AvgRAM_A_DO[20] ^ AvgRAM_A_DO[19] ^ AvgRAM_A_DO[18] ^ AvgRAM_A_DO[17] ^ AvgRAM_A_DO[16] == 0) ? 0 : 1;
assign AvgRAM_A_parityerr[3] = (AvgRAM_A_DOP[3] ^ AvgRAM_A_DO[31] ^ AvgRAM_A_DO[30] ^ AvgRAM_A_DO[29] ^ AvgRAM_A_DO[28] ^ AvgRAM_A_DO[27] ^ AvgRAM_A_DO[26] ^ AvgRAM_A_DO[25] ^ AvgRAM_A_DO[24] == 0) ? 0 : 1;

assign AvgRAM_A_parity_error = |AvgRAM_A_parityerr[3:0];




///////////// B side
//calculate parity bits to store with data
assign AvgRAM_B_DIP[0] = AvgRAM_B_DI[7]  ^ AvgRAM_B_DI[6]  ^ AvgRAM_B_DI[5]  ^ AvgRAM_B_DI[4]  ^ AvgRAM_B_DI[3]  ^ AvgRAM_B_DI[2]  ^ AvgRAM_B_DI[1]  ^ AvgRAM_B_DI[0];
assign AvgRAM_B_DIP[1] = AvgRAM_B_DI[15] ^ AvgRAM_B_DI[14] ^ AvgRAM_B_DI[13] ^ AvgRAM_B_DI[12] ^ AvgRAM_B_DI[11] ^ AvgRAM_B_DI[10] ^ AvgRAM_B_DI[9]  ^ AvgRAM_B_DI[8];
assign AvgRAM_B_DIP[2] = AvgRAM_B_DI[23] ^ AvgRAM_B_DI[22] ^ AvgRAM_B_DI[21] ^ AvgRAM_B_DI[20] ^ AvgRAM_B_DI[19] ^ AvgRAM_B_DI[18] ^ AvgRAM_B_DI[17] ^ AvgRAM_B_DI[16];
assign AvgRAM_B_DIP[3] = AvgRAM_B_DI[31] ^ AvgRAM_B_DI[30] ^ AvgRAM_B_DI[29] ^ AvgRAM_B_DI[28] ^ AvgRAM_B_DI[27] ^ AvgRAM_B_DI[26] ^ AvgRAM_B_DI[25] ^ AvgRAM_B_DI[24];

//calculate error detected by parity bits from read data

assign AvgRAM_B_parityerr[0] = (AvgRAM_B_DOP[0] ^ AvgRAM_B_DO[7]  ^ AvgRAM_B_DO[6]  ^ AvgRAM_B_DO[5]  ^ AvgRAM_B_DO[4]  ^ AvgRAM_B_DO[3]  ^ AvgRAM_B_DO[2]  ^ AvgRAM_B_DO[1]  ^ AvgRAM_B_DO[0] == 0)  ? 0 : 1;
assign AvgRAM_B_parityerr[1] = (AvgRAM_B_DOP[1] ^ AvgRAM_B_DO[15] ^ AvgRAM_B_DO[14] ^ AvgRAM_B_DO[13] ^ AvgRAM_B_DO[12] ^ AvgRAM_B_DO[11] ^ AvgRAM_B_DO[10] ^ AvgRAM_B_DO[9]  ^ AvgRAM_B_DO[8] == 0)  ? 0 : 1;
assign AvgRAM_B_parityerr[2] = (AvgRAM_B_DOP[2] ^ AvgRAM_B_DO[23] ^ AvgRAM_B_DO[22] ^ AvgRAM_B_DO[21] ^ AvgRAM_B_DO[20] ^ AvgRAM_B_DO[19] ^ AvgRAM_B_DO[18] ^ AvgRAM_B_DO[17] ^ AvgRAM_B_DO[16] == 0) ? 0 : 1;
assign AvgRAM_B_parityerr[3] = (AvgRAM_B_DOP[3] ^ AvgRAM_B_DO[31] ^ AvgRAM_B_DO[30] ^ AvgRAM_B_DO[29] ^ AvgRAM_B_DO[28] ^ AvgRAM_B_DO[27] ^ AvgRAM_B_DO[26] ^ AvgRAM_B_DO[25] ^ AvgRAM_B_DO[24] == 0) ? 0 : 1;

assign AvgRAM_B_parity_error = |AvgRAM_B_parityerr[3:0];



assign AvgRAM_ADDR[8:0] = (read_out_trigger==1'b1 ? read_addr[9:1] : AvgRAM_ADDR_r[8:0]);

always @(posedge FPGA_CLK or negedge FPGA_RESET)
	begin
		if(!FPGA_RESET)
			begin
				RAMFSM=RAM_IDLE;
				AvgRAM_EN = 1'b0;
				AvgRAM_A_WE = 1'b0;
				AvgRAM_B_WE = 1'b0;
				AvgRAM_A_DI[31:0] = 32'h00000000;
				AvgRAM_B_DI[31:0] = 32'h00000000;
				AvgRAM_ADDR_r[8:0] = 9'b0_0000_0000;
			end
		else
			begin
				RAMFSM=RAMFSMn;
				AvgRAM_EN = AvgRAM_EN_i;
				AvgRAM_A_WE = AvgRAM_A_WE_i;
				AvgRAM_B_WE = AvgRAM_B_WE_i;
				
				if(load_new_sum_A_i==1'b1)
					begin
						if(cap_sel==1'b0) AvgRAM_A_DI[31:0] = {12'h000,cap_data_out_1[19:0]};
						else AvgRAM_A_DI[31:0] = {12'h000,cap_data_out_0[19:0]};
					end
				if(load_new_sum_B_i==1'b1)
					begin
						if(cap_sel==1'b0) AvgRAM_B_DI[31:0] = {12'h000,cap_data_out_1[19:0]};
						else AvgRAM_B_DI[31:0] = {12'h000,cap_data_out_0[19:0]};
					end
				
				if(sum_data_A_i==1'b1)
					begin
						if(cap_sel==1'b0) AvgRAM_A_DI[31:0] = AvgRAM_A_DO[31:0]+{12'h000,cap_data_out_1[19:0]};
						else AvgRAM_A_DI[31:0] = AvgRAM_A_DO[31:0]+{12'h000,cap_data_out_0[19:0]};
					end
				if(sum_data_B_i==1'b1)
					begin
						if(cap_sel==1'b0) AvgRAM_B_DI[31:0] = AvgRAM_B_DO[31:0]+{12'h000,cap_data_out_1[19:0]};
						else AvgRAM_B_DI[31:0] = AvgRAM_B_DO[31:0]+{12'h000,cap_data_out_0[19:0]};
					end
					
				if(reset_ram_addr_i==1'b1) AvgRAM_ADDR_r[8:0] = 9'b0_0000_0000;
				if(incr_ram_addr_i==1'b1) AvgRAM_ADDR_r[8:0] = AvgRAM_ADDR_r[8:0] + 9'b0_0000_0001;
			end
	end


always @(RAMFSM or
			trigger_store_sum or
			FIRST_READINGS or
			RESET_AVGRAM_ADDR or
			TRIGGER_READ_RAM or
			CONV_A0_B1)
	begin
		RAMFSMn=RAMFSM;
		AvgRAM_EN_i=1'b1;
		AvgRAM_A_WE_i=1'b0;
		AvgRAM_B_WE_i=1'b0;
		
		load_new_sum_A_i=1'b0;
		load_new_sum_B_i=1'b0;
		
		sum_data_A_i=1'b0;
		sum_data_B_i=1'b0;
		
		reset_ram_addr_i=1'b0;
		incr_ram_addr_i=1'b0;
		
		read_out_trigger=1'b0;
		
		case(RAMFSM)
		
			RAM_IDLE:
				begin
					RAMFSMn=RAM_IDLE;
					if(RESET_AVGRAM_ADDR==1'b1) reset_ram_addr_i=1'b1;
					if(trigger_store_sum==1'b1)
						begin
							if(FIRST_READINGS[1]==1'b0)
								begin
									//yes, this is a first reading.
									//just load the data into the sum register (add to 0?).
									//and store it.
									RAMFSMn=NEW_SUM;
								end
							else
								begin
									//no, this is not a first reading.
									//first read the old sum.
									//then add the new data to it.
									//and store the new sum.
									RAMFSMn=EXISTING_SUM;
								end
						end
					else
       					   begin
       					       if(TRIGGER_READ_RAM==1'b1)
       					          begin
       					              RAMFSMn=READ_RAM;
       					              reset_ram_addr_i=1'b1;
   					          end
   					   end
   					       
				end
				
			NEW_SUM:
				begin
					if(CONV_A0_B1==1'b0)
						begin
							//A side
							load_new_sum_A_i=1'b1;
							RAMFSMn=RAM_WRITE_A;
						end
					else
						begin
							//B side
							load_new_sum_B_i=1'b1;
							RAMFSMn=RAM_WRITE_B;
						end
				end
				
			EXISTING_SUM:
				begin
					if(CONV_A0_B1==1'b0)
						begin
							//A side
							sum_data_A_i=1'b1;
							RAMFSMn=RAM_WRITE_A;
						end
					else //(CONV_A0_B1==1'b1)
						begin
							//B side
							sum_data_B_i=1'b1;
							RAMFSMn=RAM_WRITE_B;
						end
				end
			
			RAM_WRITE_A:
				begin
					RAMFSMn=RAM_WAIT;
					AvgRAM_A_WE_i=1'b1;
				end
			
			RAM_WRITE_B:
				begin
					RAMFSMn=RAM_WAIT;
					AvgRAM_B_WE_i=1'b1;
				end
				
			RAM_WAIT:
				begin
					RAMFSMn=RAM_INCR_ADDR;
				end
				
			RAM_INCR_ADDR:
			   begin
			      RAMFSMn=RAM_IDLE;
					incr_ram_addr_i=1'b1;
			   end
			
			READ_RAM:
			   begin
			      read_out_trigger=1'b1;
			      RAMFSMn=READ_RAM_WAIT;
			   end  
			
			READ_RAM_WAIT:
			   begin
			      if(TRIGGER_READ_RAM==1'b1)
			         begin
			            read_out_trigger=1'b1;
      			            RAMFSMn=READ_RAM_WAIT;
 			         end
 			      else
 			         begin
 			             RAMFSMn=RAM_IDLE;
 			         end
 			            
			   end    
				
			default:
				begin
					RAMFSMn=RAM_IDLE;
				end
				
		endcase
	end

















always @(posedge FPGA_CLK or negedge FPGA_RESET)
	begin
		if(FPGA_RESET==1'b0)
			begin
				AVG_DATA_OUTPUT[15:0]=16'h0000;
			end
		else
			begin
				case({AB_AVG_SEL,read_addr[0]})
					2'b00: 
						begin
							AVG_DATA_OUTPUT[15:0]=AvgRAM_A_DO[15:0];
						end
					2'b01: 	
						begin
							AVG_DATA_OUTPUT[15:0]=AvgRAM_A_DO[31:16];
						end
					2'b10: 
						begin
							AVG_DATA_OUTPUT[15:0]=AvgRAM_B_DO[15:0];
						end
					2'b11: 	
						begin
							AVG_DATA_OUTPUT[15:0]=AvgRAM_B_DO[31:16];
						end
					default: 
						begin
							AVG_DATA_OUTPUT[15:0]=16'hAAAA;
						end
				endcase
			end
	end


always @(posedge FPGA_CLK or negedge FPGA_RESET)
	begin
		if(FPGA_RESET==1'b0)
			begin
				oFSM=oIDLE;
				AVG_DATA_AVAILABLE_FOR_WRITE=1'b0;
				AVG_DATA_LOADED=1'b0;
				usb_write_data_requested_gated=1'b0;
				usb_write_data_processed_gated=1'b0;
				read_addr[9:0]=10'h000;
			end
		else
			begin
				oFSM=oFSMn;
				AVG_DATA_AVAILABLE_FOR_WRITE=data_available_for_write_i;
				AVG_DATA_LOADED=data_loaded_for_usb_i;
				usb_write_data_requested_gated=USB_WRITE_DATA_REQUESTED;
				usb_write_data_processed_gated=USB_WRITE_DATA_PROCESSED;
				if(reset_reg_address_i==1'b1) read_addr[9:0]=10'h000;
				if(incr_reg_address_i==1'b1) read_addr[9:0]=read_addr[9:0]+10'h001;
			end
	end




always @(	oFSM or
				read_out_trigger or
				usb_write_data_requested_gated or
				usb_write_data_processed_gated or
				read_addr or
				TRIGGER_READ_RAM or
				STOP_ADDR
				)
	begin
		data_available_for_write_i=1'b1;
		reset_reg_address_i=1'b0;
		data_loaded_for_usb_i=1'b0;
		incr_reg_address_i=1'b0;
		//done_reading_ram=1'b0;
		oFSMn=oFSM;
		
		case(oFSM)
			oIDLE:
				begin
					if(read_out_trigger==1'b1)
						begin
							oFSMn=oDATA_AVAILABLE_NOW_WAIT;
							reset_reg_address_i=1'b1;
						end
					else
						begin
							oFSMn=oIDLE;
							data_available_for_write_i=1'b0;
						end
				end
		
			oDATA_AVAILABLE_NOW_WAIT:
				begin
					if(usb_write_data_requested_gated==1'b1)
						begin
							oFSMn=oDATA_LOADED_FOR_USB;
						end
					else
						begin
							oFSMn=oDATA_AVAILABLE_NOW_WAIT;
						end
				end

			oDATA_LOADED_FOR_USB:
				begin				
					data_loaded_for_usb_i=1'b1;
					if(usb_write_data_processed_gated==1'b1)
						begin
							oFSMn=oEVALUATE_NEXT_REGISTER;
						end
					else
						begin
							oFSMn=oDATA_LOADED_FOR_USB;
						end
				end

			oEVALUATE_NEXT_REGISTER:
				begin
					if(read_addr[9:0]==STOP_ADDR)
						begin
							oFSMn=oDONE;
							data_available_for_write_i=1'b0;
						end
					else
						begin
							oFSMn=oDATA_AVAILABLE_NOW_WAIT;
							incr_reg_address_i=1'b1;
						end
				end
			
			oDONE:
				begin
					if(TRIGGER_READ_RAM==1'b0)
						begin
							oFSMn=oIDLE;
							data_available_for_write_i=1'b0;
							reset_reg_address_i=1'b1;
						end
					else
						begin
							oFSMn=oDONE;
							data_available_for_write_i=1'b0;
							//done_reading_ram=1'b1;
						end
				end

			default:
				begin
					oFSMn=oIDLE;
					data_available_for_write_i=1'b0;
				end

		endcase

	end






endmodule


