`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    10:47:51 01/23/06
// Design Name:    
// Module Name:    INPUT_SYNC
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module INPUT_SYNC( FPGA_CLK, FPGA_RESET, A, /*RESET_STATE,*/ Y, CONV, CONT_A0_B1 );
input FPGA_CLK;
input FPGA_RESET;
input A;
//input RESET_STATE;
input CONV;
output Y, CONT_A0_B1;
reg Y, CONT_A0_B1;
reg Y2;

//when CONV is low, B is integrating and if data is available, then it is A side data.

always @(posedge FPGA_CLK or negedge FPGA_RESET)
	begin
		if(FPGA_RESET==1'b0)
			begin
				Y<=1'b1;
				Y2<=1'b1;
				CONT_A0_B1<=1'b0;
			end
		else
			begin
				Y<=A;
				Y2<=Y;
				if(Y2==1'b1 && Y==1'b0)  //this catches the falling edge of DVALIDn
					begin
						if(CONV==1'b0) //if DVALIDn falls when CONV is low, then the data is ready for the previous high, which is A.
							begin
								CONT_A0_B1<=1'b1;  //A is 1, when CONV is 0, A data is ready
							end
						else
							begin
								CONT_A0_B1<=1'b0;  //B is 0, when CONV is 1, B data is ready
							end
					end
			end
	end

endmodule
