`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    16:55:09 01/06/06
// Design Name:    
// Module Name:    OPCODE_PROC
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module OPCODE_PROC(	FPGA_CLK,
							FPGA_RESET,

							USB_READ_DATA_AVAILABLE,
							READ_DATA_PROCESSED,
							DATA_FROM_USB,

							CONV_LOW_REG,
							CONV_HIGH_REG,
							CONV_WAIT_LOW_REG,
							CONV_WAIT_HIGH_REG,
							NON_CONT,
							CONV_SEL,
							RESET_CONV,
							DIVXCLK_LOW_REG,
							DIVXCLK_HIGH_REG,
							DDC_CLK_SEL,

							BITS_TO_READ,
							FORMAT,

							DDC_DATA_CLK_SEL,
							DIVXCLK_DATA_LOW_REG,
							DIVXCLK_DATA_HIGH_REG,

							DVALIDS_TO_IGNORE,	  //Ignore	0
							DVALIDS_TO_CAPTURE,	  //Readings 1
							START_CONVERSIONS,	  //start_conversions 1 and 0
							HARDWARE_TRIGGER_EN,

							CLK_CFG_OUT,
							DIN_CFG_OUT,

							DCLK_WAIT_COUNT,
							DDC_RESETN_OUT,
							
                     
                     TRIGGER,
                     DIN_CFG_LOWER_BITS,						 //phase 4
							DIN_CFG_HIGHER_BITS,						 //phase 4

							//RAM_ADDRESS_FOR_LOAD,
							//DATA_FOR_RAM

							OPCODE_DATA_OUTPUT,						//opcode_data_output_w[15:0]
							OPCODE_DATA_AVAILABLE_FOR_WRITE,		//opcode_data_available_for_write_w
							USB_WRITE_DATA_REQUESTED,			   //usb_write_data_requested_w
							OPCODE_DATA_LOADED,				      //opcode_data_loaded_w
							USB_WRITE_DATA_PROCESSED,		      //usb_write_data_processed_w
							DCLK_SELECT_MANUAL_OR_AUTO,								 
							DCLK_MANUAL_SET_VALUE,								 
							DOUT_IN,
							
							FORMAT_DIN_CFG,
							REG_FREQ_DIV_DIN_CLK_HIGH,
							REG_FREQ_DIV_DIN_CLK_LOW,
							FIRMWARE_VERSION,
                     STOP_ADDR,
                     AB_AVG_SEL,
                     TRIGGER_READ_AVG_RAM,
                     READ_OUT_OPCODE_DATA_TRIGGER,
							USE_RAM_CHIPS,
							DONE_READ,
							CLKDELAY_AROUND_CONV,
							BOARD,
							
							SEND_PACKET
							);

input	FPGA_CLK;
input FPGA_RESET;

input [15:0] FIRMWARE_VERSION;

output DCLK_MANUAL_SET_VALUE;
reg DCLK_MANUAL_SET_VALUE;

input DOUT_IN;
output DCLK_SELECT_MANUAL_OR_AUTO;
reg DCLK_SELECT_MANUAL_OR_AUTO;

input USB_READ_DATA_AVAILABLE;

output READ_DATA_PROCESSED;
reg READ_DATA_PROCESSED;

output [7:0] DIN_CFG_LOWER_BITS;
reg [7:0] DIN_CFG_LOWER_BITS;

output [7:0] DIN_CFG_HIGHER_BITS;
reg [7:0] DIN_CFG_HIGHER_BITS;

output TRIGGER;
reg TRIGGER;

output [3:0] REG_FREQ_DIV_DIN_CLK_HIGH;
reg [3:0] REG_FREQ_DIV_DIN_CLK_HIGH;

output [3:0] REG_FREQ_DIV_DIN_CLK_LOW;
reg [3:0] REG_FREQ_DIV_DIN_CLK_LOW;

input [15:0] DATA_FROM_USB;

output [23:0] CONV_LOW_REG, CONV_HIGH_REG;
reg [23:0] CONV_LOW_REG, CONV_HIGH_REG;

output [15:0] CONV_WAIT_LOW_REG, CONV_WAIT_HIGH_REG;
reg [15:0] CONV_WAIT_LOW_REG, CONV_WAIT_HIGH_REG;

output NON_CONT;
reg NON_CONT;

output [1:0] CONV_SEL;
reg [1:0] CONV_SEL;

output RESET_CONV;
reg RESET_CONV;

output [3:0] DIVXCLK_LOW_REG, DIVXCLK_HIGH_REG;
reg [3:0] DIVXCLK_LOW_REG, DIVXCLK_HIGH_REG;

output [2:0] DDC_CLK_SEL;
reg [2:0] DDC_CLK_SEL;

output [14:0] BITS_TO_READ;
reg [14:0] BITS_TO_READ;

output FORMAT;
reg FORMAT;

output FORMAT_DIN_CFG;
reg  FORMAT_DIN_CFG;

output [3:0] DIVXCLK_DATA_LOW_REG, DIVXCLK_DATA_HIGH_REG;
reg [3:0] DIVXCLK_DATA_LOW_REG, DIVXCLK_DATA_HIGH_REG;

output [2:0] DDC_DATA_CLK_SEL;
reg [2:0] DDC_DATA_CLK_SEL;

output [7:0] DVALIDS_TO_IGNORE;
reg [7:0] DVALIDS_TO_IGNORE;
output [23:0] DVALIDS_TO_CAPTURE;
reg [23:0] DVALIDS_TO_CAPTURE;
output START_CONVERSIONS;
reg START_CONVERSIONS;
output HARDWARE_TRIGGER_EN;
reg HARDWARE_TRIGGER_EN;

output CLK_CFG_OUT, DIN_CFG_OUT;
reg CLK_CFG_OUT, DIN_CFG_OUT;

output [15:0] DCLK_WAIT_COUNT;
reg [15:0] DCLK_WAIT_COUNT;

output DDC_RESETN_OUT;
reg DDC_RESETN_OUT;

//output DIN_OUT;
//reg DIN_OUT;

output [15:0] OPCODE_DATA_OUTPUT;
reg [15:0] OPCODE_DATA_OUTPUT;


output OPCODE_DATA_AVAILABLE_FOR_WRITE;
reg OPCODE_DATA_AVAILABLE_FOR_WRITE;
input USB_WRITE_DATA_REQUESTED;
output OPCODE_DATA_LOADED;
reg OPCODE_DATA_LOADED;
input USB_WRITE_DATA_PROCESSED;

reg READ_DATA_PROCESSED_i;
reg usb_read_data_available_gated;
reg FSM, FSMn;

output [9:0] STOP_ADDR;
reg [9:0] STOP_ADDR;
output AB_AVG_SEL, TRIGGER_READ_AVG_RAM;
reg AB_AVG_SEL, TRIGGER_READ_AVG_RAM;

output READ_OUT_OPCODE_DATA_TRIGGER;
wire READ_OUT_OPCODE_DATA_TRIGGER;

output USE_RAM_CHIPS;
reg USE_RAM_CHIPS;

input DONE_READ;

output [7:0] CLKDELAY_AROUND_CONV;
reg [7:0] CLKDELAY_AROUND_CONV;

input [1:0] BOARD;

output SEND_PACKET;
reg SEND_PACKET;

reg 	[3:0]	FSM_FPGA_REG_READBACK, FSM_FPGA_REG_READBACKn;
reg	[7:0] reg_address;
reg 	data_available_for_write_i;
reg	reset_reg_address_i;
reg	data_loaded_for_usb_i;
reg	incr_reg_address_i;
reg	usb_write_data_requested_gated;
reg	usb_write_data_processed_gated;
reg   read_out_trigger;
reg 	format_i;
reg   freq_div;
reg	makeShift;
//reg	finishRead;

parameter	oIDLE=4'h0,
				oDATA_AVAILABLE_NOW_WAIT=4'h1,
				oDATA_LOADED_FOR_USB=4'h2,
				oEVALUATE_NEXT_REGISTER=4'h3,
				oDONE=4'hF;



parameter IDLE=1'b0;
parameter DO_OP=1'b1;

parameter ooIDLE = 3'b000,
			 ooWAIT_UNTIL_CLK_TM_HIGH = 3'b001,
			 ooWAIT_UNTIL_CLK_TM_FALL = 3'b011,
			 ooWait_2 = 3'b100,
			 ooWait_3 = 3'b101,
			 ooREAD_AFTER_CLK_TM_RISE = 3'b110,
			 ooDONE = 3'b111;

parameter RESET_ALL = 8'hFF;



//reg NO_OP_i,
reg LOAD_CONV_LOW_REG_MSB_i,
  	 LOAD_CONV_LOW_REG_MIDB_i,
  	 LOAD_CONV_LOW_REG_LSB_i,
  	 LOAD_CONV_HIGH_REG_MSB_i,
  	 LOAD_CONV_HIGH_REG_MIDB_i,
  	 LOAD_CONV_HIGH_REG_LSB_i,
	 
  	 LOAD_CONV_WAIT_HIGH_REG_MSB_i,
  	 LOAD_CONV_WAIT_HIGH_REG_LSB_i,
  	 LOAD_CONV_WAIT_LOW_REG_MSB_i,
  	 LOAD_CONV_WAIT_LOW_REG_LSB_i,
	 LOAD_NON_CONT_i,
	 LOAD_RESET_CONV_i,
	 LOAD_CONV_SEL_i,
	 
  	 LOAD_DIVXCLK_REGS_i,
  	 LOAD_DDC_CLK_SEL_i,
  	 LOAD_CHANNELS_AND_FORMAT_i,
  	 LOAD_DIVXCLK_DATA_REGS_i,
  	 LOAD_DDC_DATA_CLK_SEL_i,
  	 LOAD_DVALIDS_TO_IGNORE_i,
  	 LOAD_DVALIDS_TO_CAPTURE_LSB_i,
  	 LOAD_DVALIDS_TO_CAPTURE_MIDB_i,
  	 LOAD_DVALIDS_TO_CAPTURE_MSB_i,
  	 LOAD_START_CONVERSIONS_i,
	 LOAD_CLK_CFG_OUT_i,
	 LOAD_DIN_CFG_OUT_i,
	 LOAD_DCLK_WAIT_COUNT_MSB_i,
	 LOAD_DCLK_WAIT_COUNT_LSB_i,
	 LOAD_DDC_RESETN_OUT_i,	  
	 LOAD_HARDWARE_TRIGGER_EN_i,
	 LOAD_read_out_trigger_i,
	 LOAD_trigger_read_avg_ram_i,
	 LOAD_stop_addr_MSB_i,
	 LOAD_stop_addr_LSB_i,
	 LOAD_ab_avg_sel_i,
	 LOAD_use_ram_chips_i,
  	 RESET_ALL_i,
	 LOAD_dclk_select_i,  
	 LOAD_dclock_manual_i,  
	 read_DIN_CFG_higher_bits, 
	 read_DIN_CFG_lower_bits,	
	 trigger_2,		
	 read_finished,
	 LOAD_CLKDELAY_AROUND_CONV_i;
	 
reg opcode_send_packet_end_i;

assign READ_OUT_OPCODE_DATA_TRIGGER = read_out_trigger;

//synthesis attribute clock_signal READ_DATA_PROCESSED yes;

always @(posedge FPGA_CLK or negedge FPGA_RESET)
	begin
		if(FPGA_RESET==1'b0)
			begin
				SEND_PACKET=1'b0;
			end
		else
			begin
				SEND_PACKET=opcode_send_packet_end_i;
			end
	end

always @(posedge FPGA_CLK or negedge FPGA_RESET)
  begin
  if(FPGA_RESET==1'b0)
    begin
		CONV_LOW_REG[23:0] = 24'h00_0640;
		CONV_HIGH_REG[23:0] = 24'h00_0640;
		CONV_WAIT_LOW_REG[15:0] = 16'h1004;
		CONV_WAIT_HIGH_REG[15:0] = 16'h1004;
		NON_CONT = 1'b0;
		RESET_CONV=1'b1;
		CONV_SEL[1:0] = 2'b00;
		DIVXCLK_LOW_REG[3:0] = 4'h7;
		DIVXCLK_HIGH_REG[3:0] = 4'h7;
		DDC_CLK_SEL[2:0] = 3'b001;
		BITS_TO_READ[14:0] = 15'h0280;    //32 channels of 20 bits
		FORMAT = 1'b1;
		DIVXCLK_DATA_LOW_REG[3:0] = 4'h1;
		DIVXCLK_DATA_HIGH_REG[3:0] = 4'h1;
		DDC_DATA_CLK_SEL[2:0] = 3'b001;
		DVALIDS_TO_IGNORE[7:0]=8'h02;
		DVALIDS_TO_CAPTURE[23:0]=24'h000006;
		START_CONVERSIONS=1'b0;
		CLK_CFG_OUT=1'b0;
		DIN_CFG_OUT=1'b0;
		DCLK_WAIT_COUNT[15:0]=16'h0010;
		DDC_RESETN_OUT=1'b1;	
		HARDWARE_TRIGGER_EN=1'b0;
		read_out_trigger=1'b0;
		DCLK_SELECT_MANUAL_OR_AUTO=1'b0;  
		DCLK_MANUAL_SET_VALUE=1'b0;	
		//RAM_ADDRESS_FOR_LOAD[18:0] = 19'b000__0000_0000__0000_0000;
		//DATA_FOR_RAM[31:0] = 32'b0000_0000__0000_0000__0000_0000__0000_0000;
		DIN_CFG_HIGHER_BITS = 8'b0;	//phase 4
		DIN_CFG_LOWER_BITS = 8'b0;	//phase 4
		TRIGGER = 1'b0;					//phase 4
		//prove = 1'b0;
		FORMAT_DIN_CFG = 1'b0;		//phase 4
		REG_FREQ_DIV_DIN_CLK_HIGH = 4'hF;
		REG_FREQ_DIV_DIN_CLK_LOW = 4'hF;
		STOP_ADDR = 10'h004;
		AB_AVG_SEL = 1'b0;
		TRIGGER_READ_AVG_RAM = 1'b0;
		USE_RAM_CHIPS = 1'b1;
		CLKDELAY_AROUND_CONV[7:0]=8'h32; //50 in decimal
	 end
  else
  	 begin

	     if(RESET_ALL_i==1'b1)					 //FF
		    begin
			 CONV_LOW_REG[23:0] = 24'h00_0640; //h1004 = 4100 clks/conv = 340ish pC at 4.096V and 5MHz CLK over 10M
	 		 CONV_HIGH_REG[23:0] = 24'h00_0640;
			 CONV_WAIT_LOW_REG[15:0] = 16'h1004;
			 CONV_WAIT_HIGH_REG[15:0] = 16'h1004;
			 NON_CONT = 1'b0;
			 RESET_CONV = 1'b1;
			 CONV_SEL[1:0]=2'b00;
	 		 DIVXCLK_LOW_REG[3:0] = 4'h7;	//7+1 = 8; 8+8 is 80MHz div 16, so 5MHz = DDC CLK.
	 		 DIVXCLK_HIGH_REG[3:0] = 4'h7;
	       DDC_CLK_SEL[2:0] = 3'b001;
			 BITS_TO_READ[14:0] = 15'h0280;    //32 channels of 20 bits
	 	    FORMAT = 1'b1;
			 DIVXCLK_DATA_LOW_REG[3:0] = 4'h1;
	 		 DIVXCLK_DATA_HIGH_REG[3:0] = 4'h1;
			 DDC_DATA_CLK_SEL[2:0] = 3'b001; //div 4 from 80MHz is 20MHz.
			 DVALIDS_TO_IGNORE[7:0]=8'h02;
			 DVALIDS_TO_CAPTURE[23:0]=24'h000006;
			 START_CONVERSIONS=1'b0; 
	 		 CLK_CFG_OUT=1'b0;
	 		 DIN_CFG_OUT=1'b0;	
			 DCLK_WAIT_COUNT[15:0]=16'h0000;
			 DDC_RESETN_OUT=1'b1;
			 HARDWARE_TRIGGER_EN=1'b0;
			 read_out_trigger=1'b0;
			 DCLK_SELECT_MANUAL_OR_AUTO=1'b0;		 
			 DCLK_MANUAL_SET_VALUE=1'b0;		 
			 DIN_CFG_HIGHER_BITS = 8'b0;
	  		 DIN_CFG_LOWER_BITS = 8'b0;
			 TRIGGER = 1'b0;
			 FORMAT_DIN_CFG = 1'b0;
			 REG_FREQ_DIV_DIN_CLK_HIGH = 4'hF;
	  		 REG_FREQ_DIV_DIN_CLK_LOW = 4'hF;
			 STOP_ADDR = 10'h004;
			 AB_AVG_SEL = 1'b0;
			 TRIGGER_READ_AVG_RAM = 1'b0;
			 USE_RAM_CHIPS = 1'b1;
			 CLKDELAY_AROUND_CONV[7:0]=8'h32; //50 in decimal
	       end

	     if(LOAD_CONV_LOW_REG_MSB_i==1'b1)	 //01
		    begin							
			 CONV_LOW_REG[23:16] = DATA_FROM_USB[7:0];
		    end  
	     if(LOAD_CONV_LOW_REG_MIDB_i==1'b1)	 //02
		    begin
			 CONV_LOW_REG[15:8] = DATA_FROM_USB[7:0];
		    end  
	     if(LOAD_CONV_LOW_REG_LSB_i==1'b1)	 //03
		    begin
			 CONV_LOW_REG[7:0] = DATA_FROM_USB[7:0];
		    end

		    
	     if(LOAD_CONV_HIGH_REG_MSB_i==1'b1)	 //04
		    begin
			 CONV_HIGH_REG[23:16] = DATA_FROM_USB[7:0];
		    end  
	     if(LOAD_CONV_HIGH_REG_MIDB_i==1'b1)	 //05
		    begin
			 CONV_HIGH_REG[15:8] = DATA_FROM_USB[7:0];
		    end  
	     if(LOAD_CONV_HIGH_REG_LSB_i==1'b1)	 //06
		    begin
			 CONV_HIGH_REG[7:0] = DATA_FROM_USB[7:0];
		    end
			 
		  if(LOAD_CONV_WAIT_LOW_REG_MSB_i==1'b1)	 //51
		    begin							
			 CONV_WAIT_LOW_REG[15:8] = DATA_FROM_USB[7:0];
		    end  
	     if(LOAD_CONV_WAIT_LOW_REG_LSB_i==1'b1)	 //52
		    begin
			 CONV_WAIT_LOW_REG[7:0] = DATA_FROM_USB[7:0];
		    end

		    
			if(LOAD_CONV_WAIT_HIGH_REG_MSB_i==1'b1)	 //53
				begin
				CONV_WAIT_HIGH_REG[15:8] = DATA_FROM_USB[7:0];
				end   
			if(LOAD_CONV_WAIT_HIGH_REG_LSB_i==1'b1)	 //54
				begin
				CONV_WAIT_HIGH_REG[7:0] = DATA_FROM_USB[7:0];
				end

		     
			if(LOAD_NON_CONT_i==1'b1)	 //55
				begin
				NON_CONT = DATA_FROM_USB[0];
				end 
			 
			if(LOAD_RESET_CONV_i==1'b1)   //56
				begin
				RESET_CONV = DATA_FROM_USB[0];
				end

			if(LOAD_CONV_SEL_i == 1'b1)  //57
				begin
				CONV_SEL[1:0] = DATA_FROM_USB[1:0];
				end
			 

		  if(LOAD_DIVXCLK_REGS_i==1'b1)			 //07
		    begin
				 DIVXCLK_LOW_REG[3:0] = DATA_FROM_USB[3:0];
				 DIVXCLK_HIGH_REG[3:0] = DATA_FROM_USB[7:4];
		    end
		  if(LOAD_DDC_CLK_SEL_i==1'b1)			 //08
		    begin
				DDC_CLK_SEL[2:0] = DATA_FROM_USB[2:0];
			 end

		  if(LOAD_CHANNELS_AND_FORMAT_i==1'b1) //09
		    begin
			   FORMAT=DATA_FROM_USB[4];
			   if(DATA_FROM_USB[4]==1'b0) // 0 = 16 bit
				  begin
			     case(DATA_FROM_USB[3:0])
				  		default:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__0000_1111;  //1   
								BITS_TO_READ[14:0] = 15'h0010;  //1   
							end
				  		4'b0000:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__0000_1111;  //1   
								BITS_TO_READ[14:0] = 15'h0010;  //1
							end
				  		4'b0001:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__0001_1111;	//2 		
								BITS_TO_READ[14:0] = 15'h0020;  //2
							end
						4'b0010:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__0011_1111;	//4 
								BITS_TO_READ[14:0] = 15'h0040;  //4
							end
				  		4'b0011:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__0111_1111;	//8 
								BITS_TO_READ[14:0] = 15'h0080;  //8  
							end
				  		4'b0100:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__1111_1111;	//16 
								BITS_TO_READ[14:0] = 15'h0100;  //16 
							end
				  		4'b0101:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0001__1111_1111;	//32 
								BITS_TO_READ[14:0] = 15'h0200;  //32 
							end
				  		4'b0110:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0011__1111_1111;	//64 
								BITS_TO_READ[14:0] = 15'h0400;  //64 
							end
				  		4'b0111:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0111__1111_1111;	//128 
								BITS_TO_READ[14:0] = 15'h0800;  //128
							end
				  		4'b1000:
							begin
								//BITS_TO_READ[14:0] = 15'b000_1111__1111_1111;	//256 
								BITS_TO_READ[14:0] = 15'h1000;  //256
							end
				  		4'b1001:
							begin
								//BITS_TO_READ[14:0] = 15'b001_1111__1111_1111;	//512 
								BITS_TO_READ[14:0] = 15'h2000;  //512
							end
				  		4'b1010:
							begin
								//BITS_TO_READ[14:0] = 15'b011_1111__1111_1111;	//1024 
								BITS_TO_READ[14:0] = 15'h4000;  //1024
							end
						4'b1011:
							begin
								//BITS_TO_READ[14:0] = 15'b000_0000__0000_0000;	//0 
								BITS_TO_READ[14:0] = 15'h0000;  //0
							end
						   
						4'b1111:  //this is a case never to be used!
							begin
							   BITS_TO_READ[14:0] = 15'h7FFF;  
							end
						endcase
				  end
				else //(DATA_FROM_USB[4]==1'b1)  // 1 = 20 bit
				  begin
			     		case(DATA_FROM_USB[3:0])
							default:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0000__0001_0011;  //1
								   BITS_TO_READ[14:0] = 15'h0014;  //1   5'b10100=5'h0014
								end
							4'b0000:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0000__0001_0011;  //1
								   BITS_TO_READ[14:0] = 15'h0014;  //1   5'b10100=5'h0014
								end
							4'b0001:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0000__0010_0111;	//2 
								   BITS_TO_READ[14:0] = 15'h0028;  //1   5'b10100=5'h0014
								end
							4'b0010:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0000__0100_1111;	//4
								   BITS_TO_READ[14:0] = 15'h0050;  //1   5'b10100=5'h0014
								end
							4'b0011:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0000__1001_1111;	//8 
								   BITS_TO_READ[14:0] = 15'h00A0;  //1   5'b10100=5'h0014
								end
							4'b0100:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0001__0011_1111;	//16 
								   BITS_TO_READ[14:0] = 15'h0140;  //1   5'b10100=5'h0014
								end
							4'b0101:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0010__0111_1111;	//32	
								   BITS_TO_READ[14:0] = 15'h0280;  //1   5'b10100=5'h0014
								end
							4'b0110:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0100__1111_1111;	//64	
								   BITS_TO_READ[14:0] = 15'h0500;  //1   5'b10100=5'h0014
								end
							4'b0111:
								begin
									//BITS_TO_READ[14:0] = 15'b000_1001__1111_1111;	//128	
								   BITS_TO_READ[14:0] = 15'h0A00;  //1   5'b10100=5'h0014 
								end
							4'b1000:
								begin
									//BITS_TO_READ[14:0] = 15'b001_0011__1111_1111;	//256	
								   BITS_TO_READ[14:0] = 15'h1400;  //1   5'b10100=5'h0014 
								end
							4'b1001:
								begin
									//BITS_TO_READ[14:0] = 15'b010_0111__1111_1111;	//512	
								   BITS_TO_READ[14:0] = 15'h2800;  //1   5'b10100=5'h0014
								end
							4'b1010:
								begin
									//BITS_TO_READ[14:0] = 15'b100_1111__1111_1111;	//1024  
								   BITS_TO_READ[14:0] = 15'h5000;  //1   5'b10100=5'h0014
								end
							4'b1011:
								begin
									//BITS_TO_READ[14:0] = 15'b000_0000__0000_0000;	//0
								   BITS_TO_READ[14:0] = 15'h0000;  //1   5'b10100=5'h0014
								end
						   
							4'b1111:  //this is a case never to be used!
								begin
								   BITS_TO_READ[14:0] = 15'h7FFF;  
								end
						endcase
				  end
			 end


		  if(LOAD_DIVXCLK_DATA_REGS_i==1'b1)			 //0A
		    begin
				 DIVXCLK_DATA_LOW_REG[3:0] = DATA_FROM_USB[3:0]; //4'b1110;
				 DIVXCLK_DATA_HIGH_REG[3:0] = DATA_FROM_USB[7:4]; //4'b1110;
		    end
		  if(LOAD_DDC_DATA_CLK_SEL_i==1'b1)			 //0B
		    begin
				DDC_DATA_CLK_SEL[2:0] = DATA_FROM_USB[2:0]; //3'b010;
			 end

		  if(LOAD_DVALIDS_TO_IGNORE_i==1'b1)
		    begin
				DVALIDS_TO_IGNORE[7:0] = DATA_FROM_USB[7:0];
			 end

		  if(LOAD_DVALIDS_TO_CAPTURE_LSB_i==1'b1)
		    begin
				DVALIDS_TO_CAPTURE[7:0] = DATA_FROM_USB[7:0];
			 end

		  if(LOAD_DVALIDS_TO_CAPTURE_MIDB_i==1'b1)
		    begin
				DVALIDS_TO_CAPTURE[15:8] = DATA_FROM_USB[7:0];
			 end

		  if(LOAD_DVALIDS_TO_CAPTURE_MSB_i==1'b1)
		    begin
				DVALIDS_TO_CAPTURE[23:16] = DATA_FROM_USB[7:0];
			 end

		  if(LOAD_START_CONVERSIONS_i==1'b1)
		    begin
				START_CONVERSIONS = DATA_FROM_USB[0];
			 end

		  if(LOAD_CLK_CFG_OUT_i==1'b1)
		  		begin
					CLK_CFG_OUT = DATA_FROM_USB[0];
				end
				
		  if(LOAD_DIN_CFG_OUT_i==1'b1)
		  	begin
		   	DIN_CFG_OUT = DATA_FROM_USB[0];
			end

		 if(LOAD_DCLK_WAIT_COUNT_MSB_i==1'b1)
			 begin
				DCLK_WAIT_COUNT[15:8]=DATA_FROM_USB[7:0];
			 end

		 if(LOAD_DCLK_WAIT_COUNT_LSB_i==1'b1)
			 begin
				DCLK_WAIT_COUNT[7:0]=DATA_FROM_USB[7:0];
			 end

		 if(LOAD_DDC_RESETN_OUT_i==1'b1)
			 begin
				DDC_RESETN_OUT=DATA_FROM_USB[0];	
			 end

		 if(LOAD_HARDWARE_TRIGGER_EN_i==1'b1)
		 	 begin
				HARDWARE_TRIGGER_EN=DATA_FROM_USB[0];
			 end




       if(LOAD_trigger_read_avg_ram_i==1'b1)
          begin
				TRIGGER_READ_AVG_RAM = DATA_FROM_USB[0];
			 end
			 
		 if(LOAD_stop_addr_MSB_i==1'b1)
		    begin
				STOP_ADDR[9:8] = DATA_FROM_USB[1:0];
          end
			 
		 if(LOAD_stop_addr_LSB_i==1'b1)
		    begin
				STOP_ADDR[7:0] = DATA_FROM_USB[7:0];
          end
          
       if(LOAD_ab_avg_sel_i==1'b1)
          begin
				AB_AVG_SEL = DATA_FROM_USB[0];
          end
			 
		 if(LOAD_use_ram_chips_i==1'b1)
			 begin
				USE_RAM_CHIPS=DATA_FROM_USB[0];
			 end

		 if(LOAD_read_out_trigger_i==1'b1)
 		 	 begin
				read_out_trigger=DATA_FROM_USB[0];
			 end


		 if(LOAD_dclk_select_i==1'b1)
 		 	 begin
				DCLK_SELECT_MANUAL_OR_AUTO=DATA_FROM_USB[0];
			 end

		  if(LOAD_dclock_manual_i==1'b1)
 		 	 begin
				DCLK_MANUAL_SET_VALUE=DATA_FROM_USB[0];
			 end

		  if(read_DIN_CFG_higher_bits == 1'b1)
			  begin
					DIN_CFG_HIGHER_BITS = DATA_FROM_USB[7:0];
			  end

  		  if(read_DIN_CFG_lower_bits == 1'b1)
			  begin
				  DIN_CFG_LOWER_BITS = DATA_FROM_USB[7:0];
			  end

		  if(trigger_2 == 1'b1)
			  begin
				TRIGGER = DATA_FROM_USB[0];
			  end

		  if(format_i == 1'b1)
			  begin
				 FORMAT_DIN_CFG = DATA_FROM_USB[0];
			  end

		  if(freq_div == 1'b1)
			  begin
				 REG_FREQ_DIV_DIN_CLK_HIGH = DATA_FROM_USB[7:4];
				 REG_FREQ_DIV_DIN_CLK_LOW = DATA_FROM_USB[3:0];
			  end
			 
		if(LOAD_CLKDELAY_AROUND_CONV_i==1'b1)
			begin
				CLKDELAY_AROUND_CONV[7:0]=DATA_FROM_USB[7:0];
			end
			 
//		if(din_i == 1'b1)
//			 begin
//				DIN_OUT = DATA_FROM_USB[0];
//			 end 	
			 
			
	 
	 end
  end

always @( posedge FPGA_CLK or negedge FPGA_RESET )
  begin
    if(FPGA_RESET==1'b0)
	   begin
		FSM=IDLE;
		READ_DATA_PROCESSED=1'b1;
		usb_read_data_available_gated=1'b0;
		end
	 else
	   begin
		FSM=FSMn;
		READ_DATA_PROCESSED=READ_DATA_PROCESSED_i;
		usb_read_data_available_gated=USB_READ_DATA_AVAILABLE;
		end
  end

always @(	FSM or
				usb_read_data_available_gated or
				DATA_FROM_USB[15] or
				DATA_FROM_USB[14] or
				DATA_FROM_USB[13] or
				DATA_FROM_USB[12] or
				DATA_FROM_USB[11] or
				DATA_FROM_USB[10] or
				DATA_FROM_USB[9] or
				DATA_FROM_USB[8]
				)
  begin
  	 FSMn=FSM;
  	 READ_DATA_PROCESSED_i=1'b0;
  	 
  	 //NO_OP_i=1'b0;
  	 LOAD_CONV_LOW_REG_MSB_i=1'b0;
  	 LOAD_CONV_LOW_REG_MIDB_i=1'b0;
  	 LOAD_CONV_LOW_REG_LSB_i=1'b0;
  	 LOAD_CONV_HIGH_REG_MSB_i=1'b0;
  	 LOAD_CONV_HIGH_REG_MIDB_i=1'b0;
  	 LOAD_CONV_HIGH_REG_LSB_i=1'b0;
	 
  	 LOAD_CONV_WAIT_LOW_REG_MSB_i=1'b0;
  	 LOAD_CONV_WAIT_LOW_REG_LSB_i=1'b0;
  	 LOAD_CONV_WAIT_HIGH_REG_MSB_i=1'b0;
  	 LOAD_CONV_WAIT_HIGH_REG_LSB_i=1'b0;
	 LOAD_CONV_SEL_i=1'b0;
	 LOAD_NON_CONT_i=1'b0;
	 LOAD_RESET_CONV_i=1'b0;
	 
  	 LOAD_DIVXCLK_REGS_i=1'b0;
  	 LOAD_DDC_CLK_SEL_i=1'b0;
  	 LOAD_CHANNELS_AND_FORMAT_i=1'b0;
  	 LOAD_DIVXCLK_DATA_REGS_i=1'b0;
  	 LOAD_DDC_DATA_CLK_SEL_i=1'b0;
  	 LOAD_DVALIDS_TO_IGNORE_i=1'b0;
  	 LOAD_DVALIDS_TO_CAPTURE_LSB_i=1'b0;
  	 LOAD_DVALIDS_TO_CAPTURE_MIDB_i=1'b0;
  	 LOAD_DVALIDS_TO_CAPTURE_MSB_i=1'b0;
  	 LOAD_START_CONVERSIONS_i=1'b0;
	 LOAD_CLK_CFG_OUT_i=1'b0;
	 LOAD_DIN_CFG_OUT_i=1'b0;	  
	 LOAD_DCLK_WAIT_COUNT_MSB_i=1'b0;
	 LOAD_DCLK_WAIT_COUNT_LSB_i=1'b0;
	 LOAD_DDC_RESETN_OUT_i=1'b0;
	 LOAD_HARDWARE_TRIGGER_EN_i=1'b0;
  	 RESET_ALL_i=1'b0;
	 LOAD_read_out_trigger_i=1'b0;
	 LOAD_dclk_select_i = 1'b0; 
	 LOAD_dclock_manual_i = 1'b0; 
	 read_DIN_CFG_higher_bits = 1'b0; 	 //phase 4
	 read_DIN_CFG_lower_bits = 1'b0;		//phase 4
	 trigger_2 = 1'b0;
	 format_i = 1'b0;						//phase 4
	 freq_div = 1'b0;
	 read_finished = 1'b0;
	 LOAD_trigger_read_avg_ram_i=1'b0;
    LOAD_stop_addr_MSB_i=1'b0;
    LOAD_stop_addr_LSB_i=1'b0;
    LOAD_ab_avg_sel_i=1'b0;
	 LOAD_use_ram_chips_i=1'b0;
	 LOAD_CLKDELAY_AROUND_CONV_i=1'b0;
  	 case(FSM)
      IDLE:
		  begin
			if(usb_read_data_available_gated==1'b1)
			   begin
					FSMn=DO_OP;
					//if(DATA_FROM_USB[15:8]==8'h00) NO_OP_i=1'b1; 
					if(DATA_FROM_USB[15:8]==8'h01) LOAD_CONV_LOW_REG_MSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h02) LOAD_CONV_LOW_REG_MIDB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h03) LOAD_CONV_LOW_REG_LSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h04) LOAD_CONV_HIGH_REG_MSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h05) LOAD_CONV_HIGH_REG_MIDB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h06) LOAD_CONV_HIGH_REG_LSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h07) LOAD_DIVXCLK_REGS_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h08) LOAD_DDC_CLK_SEL_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h09) LOAD_CHANNELS_AND_FORMAT_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h0A) LOAD_DIVXCLK_DATA_REGS_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h0B) LOAD_DDC_DATA_CLK_SEL_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h0C) LOAD_DVALIDS_TO_IGNORE_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h0D) LOAD_DVALIDS_TO_CAPTURE_LSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h0E) LOAD_DVALIDS_TO_CAPTURE_MIDB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h0F) LOAD_DVALIDS_TO_CAPTURE_MSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h10) LOAD_START_CONVERSIONS_i=1'b1;		
					if(DATA_FROM_USB[15:8]==8'h11) LOAD_CLK_CFG_OUT_i=1'b1;		
					if(DATA_FROM_USB[15:8]==8'h12) LOAD_DIN_CFG_OUT_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h13) LOAD_DCLK_WAIT_COUNT_MSB_i=1'b1;
	 				if(DATA_FROM_USB[15:8]==8'h14) LOAD_DCLK_WAIT_COUNT_LSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h15) LOAD_DDC_RESETN_OUT_i=1'b1;	
					if(DATA_FROM_USB[15:8]==8'h16) LOAD_HARDWARE_TRIGGER_EN_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h1A) LOAD_dclk_select_i = 1'b1;	
					if(DATA_FROM_USB[15:8]==8'h1B) LOAD_dclock_manual_i = 1'b1;
					if(DATA_FROM_USB[15:8]==8'h1C) read_DIN_CFG_higher_bits = 1'b1;	
					if(DATA_FROM_USB[15:8]==8'h1D) read_DIN_CFG_lower_bits = 1'b1;
					if(DATA_FROM_USB[15:8]==8'h1E) trigger_2 = 1'b1;
					if(DATA_FROM_USB[15:8]==8'h1F) format_i = 1'b1;
					if(DATA_FROM_USB[15:8]==8'h20) freq_div = 1'b1;
					
					
					if(DATA_FROM_USB[15:8]==8'h51) LOAD_CONV_WAIT_LOW_REG_MSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h52) LOAD_CONV_WAIT_LOW_REG_LSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h53) LOAD_CONV_WAIT_HIGH_REG_MSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h54) LOAD_CONV_WAIT_HIGH_REG_LSB_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h55) LOAD_NON_CONT_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h56) LOAD_RESET_CONV_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'h57) LOAD_CONV_SEL_i=1'b1;
					
					if(DATA_FROM_USB[15:8]==8'hD0) LOAD_read_out_trigger_i=1'b1;
					//if(DATA_FROM_USB[15:8]==8'hD1) din_i = 1'b1;
					
					if(DATA_FROM_USB[15:8]==8'hDA) LOAD_trigger_read_avg_ram_i = 1'b1;
					if(DATA_FROM_USB[15:8]==8'hDB) LOAD_stop_addr_MSB_i = 1'b1;
					if(DATA_FROM_USB[15:8]==8'hDC) LOAD_stop_addr_LSB_i = 1'b1;
					if(DATA_FROM_USB[15:8]==8'hDD) LOAD_ab_avg_sel_i = 1'b1;
					if(DATA_FROM_USB[15:8]==8'hDE) LOAD_use_ram_chips_i = 1'b1;
					
					if(DATA_FROM_USB[15:8]==8'hEB) LOAD_CLKDELAY_AROUND_CONV_i=1'b1;
					
					//if(DATA_FROM_USB[15:8]==8'h11) NO_OP_i=1'b1;
					if(DATA_FROM_USB[15:8]==8'hFF) RESET_ALL_i=1'b1;
					READ_DATA_PROCESSED_i=1'b1;
				end
			 else
			 	begin
					FSMn=IDLE;
				end
		  end
		DO_OP:
		  begin

		    if(usb_read_data_available_gated==1'b1) //if it is still 1, then just sit here doing nothing
		      begin
				  READ_DATA_PROCESSED_i=1'b1;
		  	     FSMn=DO_OP;
				end
			 else  //when it goes back to 0, then go back to waiting for the next one.
				begin
				  READ_DATA_PROCESSED_i=1'b0;
		  	     FSMn=IDLE;
				end
		  end
	 endcase
  end //end FSM block




always @(posedge FPGA_CLK or negedge FPGA_RESET)
	begin
		if(FPGA_RESET==1'b0)
			begin
				OPCODE_DATA_OUTPUT[15:0]=16'h0000;
			end
		else
			begin
				OPCODE_DATA_OUTPUT[15:8]=reg_address[7:0];
			
				case(reg_address[7:0])
					8'h01: OPCODE_DATA_OUTPUT[7:0]=CONV_LOW_REG[23:16];
					8'h02: OPCODE_DATA_OUTPUT[7:0]=CONV_LOW_REG[15:8];
					8'h03: OPCODE_DATA_OUTPUT[7:0]=CONV_LOW_REG[7:0];
					8'h04: OPCODE_DATA_OUTPUT[7:0]=CONV_HIGH_REG[23:16];
					8'h05: OPCODE_DATA_OUTPUT[7:0]=CONV_HIGH_REG[15:8];
					8'h06: OPCODE_DATA_OUTPUT[7:0]=CONV_HIGH_REG[7:0];
					8'h07: OPCODE_DATA_OUTPUT[7:0]={DIVXCLK_HIGH_REG[3:0],DIVXCLK_LOW_REG[3:0]};
					8'h08: OPCODE_DATA_OUTPUT[7:0]={5'h00,DDC_CLK_SEL[2:0]};
					8'h09: OPCODE_DATA_OUTPUT[7:0]={3'h0,{FORMAT,4'h0}}; //this one does not trasfer ideally, so 4'h0;
					8'h0A: OPCODE_DATA_OUTPUT[7:0]={DIVXCLK_DATA_HIGH_REG[3:0],DIVXCLK_DATA_LOW_REG[3:0]};
					8'h0B: OPCODE_DATA_OUTPUT[7:0]={5'h00,DDC_DATA_CLK_SEL[2:0]};
					8'h0C: OPCODE_DATA_OUTPUT[7:0]=DVALIDS_TO_IGNORE[7:0];
					8'h0D: OPCODE_DATA_OUTPUT[7:0]=DVALIDS_TO_CAPTURE[7:0];
					8'h0E: OPCODE_DATA_OUTPUT[7:0]=DVALIDS_TO_CAPTURE[15:8];
					8'h0F: OPCODE_DATA_OUTPUT[7:0]=DVALIDS_TO_CAPTURE[23:16];
					8'h10: OPCODE_DATA_OUTPUT[7:0]={6'h00,{DONE_READ,START_CONVERSIONS}};
					8'h11: OPCODE_DATA_OUTPUT[7:0]={7'h00,CLK_CFG_OUT};
					8'h12: OPCODE_DATA_OUTPUT[7:0]={7'h00,DIN_CFG_OUT};
					8'h13: OPCODE_DATA_OUTPUT[7:0]=DCLK_WAIT_COUNT[15:8];
					8'h14: OPCODE_DATA_OUTPUT[7:0]=DCLK_WAIT_COUNT[7:0];
					8'h15: OPCODE_DATA_OUTPUT[7:0]={7'h00,DDC_RESETN_OUT};
					8'h16: OPCODE_DATA_OUTPUT[7:0]={7'h00,HARDWARE_TRIGGER_EN};
					8'h1A: OPCODE_DATA_OUTPUT[7:0]={7'h00,DCLK_SELECT_MANUAL_OR_AUTO};
					8'h1B: OPCODE_DATA_OUTPUT[7:0]={6'h00,{DOUT_IN,DCLK_MANUAL_SET_VALUE}};
					8'h1C: OPCODE_DATA_OUTPUT[7:0]=DIN_CFG_HIGHER_BITS[7:0];
					8'h1D: OPCODE_DATA_OUTPUT[7:0]=DIN_CFG_LOWER_BITS[7:0];
					8'h1E: OPCODE_DATA_OUTPUT[7:0]={7'h00,TRIGGER};
					8'h1F: OPCODE_DATA_OUTPUT[7:0]={7'h00,FORMAT_DIN_CFG};
					8'h20: OPCODE_DATA_OUTPUT[7:0]={REG_FREQ_DIV_DIN_CLK_HIGH[3:0],REG_FREQ_DIV_DIN_CLK_LOW[3:0]};
					
					8'h22: OPCODE_DATA_OUTPUT[7:0]={6'h00,BOARD[1:0]};
					
					8'h51: OPCODE_DATA_OUTPUT[7:0]=CONV_WAIT_LOW_REG[15:8];
					8'h52: OPCODE_DATA_OUTPUT[7:0]=CONV_WAIT_LOW_REG[7:0];
					8'h53: OPCODE_DATA_OUTPUT[7:0]=CONV_WAIT_HIGH_REG[15:8];
					8'h54: OPCODE_DATA_OUTPUT[7:0]=CONV_WAIT_HIGH_REG[7:0];
					8'h55: OPCODE_DATA_OUTPUT[7:0]={7'h00,NON_CONT};
					8'h56: OPCODE_DATA_OUTPUT[7:0]={7'h00,RESET_CONV};
					8'h57: OPCODE_DATA_OUTPUT[7:0]={6'h00,CONV_SEL[1:0]};
					
					//8'hD1: OPCODE_DATA_OUTPUT[7:0]={7'h00,DIN_OUT}; 
					
					8'hDA: OPCODE_DATA_OUTPUT[7:0]={7'h00,TRIGGER_READ_AVG_RAM}; 
					8'hDB: OPCODE_DATA_OUTPUT[7:0]={2'h0,STOP_ADDR[9:8]}; 
					8'hDC: OPCODE_DATA_OUTPUT[7:0]=STOP_ADDR[7:0]; 
					8'hDD: OPCODE_DATA_OUTPUT[7:0]={7'h00,AB_AVG_SEL}; 
					8'hDE: OPCODE_DATA_OUTPUT[7:0]={7'h00,USE_RAM_CHIPS}; 
					
					8'hEB: OPCODE_DATA_OUTPUT[7:0]=CLKDELAY_AROUND_CONV[7:0];
					
					8'h5E: OPCODE_DATA_OUTPUT[7:0]=FIRMWARE_VERSION[15:8];
					8'h5F: OPCODE_DATA_OUTPUT[7:0]=FIRMWARE_VERSION[7:0];
					default: OPCODE_DATA_OUTPUT[7:0]=8'h00;
				endcase
			end
	end


always @(posedge FPGA_CLK or negedge FPGA_RESET)
	begin
		if(FPGA_RESET==1'b0)
			begin
				FSM_FPGA_REG_READBACK=oIDLE;
				OPCODE_DATA_AVAILABLE_FOR_WRITE=1'b0;
				OPCODE_DATA_LOADED=1'b0;
				usb_write_data_requested_gated=1'b0;
				usb_write_data_processed_gated=1'b0;
				reg_address[7:0]=8'h00;
			end
		else
			begin
				FSM_FPGA_REG_READBACK=FSM_FPGA_REG_READBACKn;
				OPCODE_DATA_AVAILABLE_FOR_WRITE=data_available_for_write_i;
				OPCODE_DATA_LOADED=data_loaded_for_usb_i;
				usb_write_data_requested_gated=USB_WRITE_DATA_REQUESTED;
				usb_write_data_processed_gated=USB_WRITE_DATA_PROCESSED;
				if(reset_reg_address_i==1'b1) reg_address[7:0]=8'h00;
				if(incr_reg_address_i==1'b1) reg_address[7:0]=reg_address[7:0]+8'h01;
			end
	end

always @(	FSM_FPGA_REG_READBACK or
				read_out_trigger or
				usb_write_data_requested_gated or
				usb_write_data_processed_gated or
				reg_address
				)
	begin
		data_available_for_write_i=1'b1;
		reset_reg_address_i=1'b0;
		data_loaded_for_usb_i=1'b0;
		incr_reg_address_i=1'b0;
		opcode_send_packet_end_i=1'b0;
		
		case(FSM_FPGA_REG_READBACK)
			oIDLE:
				begin
					if(read_out_trigger==1'b1)
						begin
							FSM_FPGA_REG_READBACKn=oDATA_AVAILABLE_NOW_WAIT;
							reset_reg_address_i=1'b1;
						end
					else
						begin
							FSM_FPGA_REG_READBACKn=oIDLE;
							data_available_for_write_i=1'b0;
						end
				end
		
			oDATA_AVAILABLE_NOW_WAIT:
				begin
					if(usb_write_data_requested_gated==1'b1)
						begin
							FSM_FPGA_REG_READBACKn=oDATA_LOADED_FOR_USB;
						end
					else
						begin
							FSM_FPGA_REG_READBACKn=oDATA_AVAILABLE_NOW_WAIT;
						end
				end

			oDATA_LOADED_FOR_USB:
				begin			
					data_loaded_for_usb_i=1'b1;
					if(usb_write_data_processed_gated==1'b1)
						begin
							FSM_FPGA_REG_READBACKn=oEVALUATE_NEXT_REGISTER;
						end
					else
						begin
							FSM_FPGA_REG_READBACKn=oDATA_LOADED_FOR_USB;
						end
				end

			oEVALUATE_NEXT_REGISTER:
				begin
					if(reg_address[7:0]==8'hFE)
						begin
							FSM_FPGA_REG_READBACKn=oDONE;
							data_available_for_write_i=1'b0;
							//opcode_send_packet_end_i=1'b1;
						end
					else
						begin
							FSM_FPGA_REG_READBACKn=oDATA_AVAILABLE_NOW_WAIT;
							incr_reg_address_i=1'b1;
						end
				end
			
			oDONE:
				begin
					if(read_out_trigger==1'b0)
						begin
							FSM_FPGA_REG_READBACKn=oIDLE;
							data_available_for_write_i=1'b0;
							reset_reg_address_i=1'b1;
						end
					else
						begin
							FSM_FPGA_REG_READBACKn=oDONE;
							data_available_for_write_i=1'b0;
							//opcode_send_packet_end_i=1'b1;
						end
				end

			default:
				begin
					FSM_FPGA_REG_READBACKn=oIDLE;
					data_available_for_write_i=1'b0;
				end

		endcase

	end



endmodule